using FitConnect.Models;
using FitConnect.Services.Models.v1.Routes;

namespace FitConnect.Services.Interfaces;

public interface IRouteService : IRestCallService {
    /// <summary>
    ///     Returns the destination id for the given intent.
    /// </summary>
    /// <param name="leikaKey"></param>
    /// <param name="ags"></param>
    /// <param name="ars"></param>
    /// <param name="areaId"></param>
    /// <returns></returns>
    Task<List<Route>> FindDestinationIdAsync(string leikaKey,
        string? ags = null,
        string? ars = null,
        string? areaId = null, int offset = 0, int limit = 500);

    /// <summary>
    /// </summary>
    /// <param name="filter"></param>
    /// <param name="offset"></param>
    /// <param name="limit"></param>
    /// <returns></returns>
    Task<AreaList?> FindAreas(List<string> filter, int offset = 0, int limit = 100);
}
